(function (){
    element = $(".custom_scroll_bar_hcat");
    element.addClass("retained");
    element.unbind("scroll");
    element.bind("scroll", function () {
    	this.scrollLeft = 0;
        this.scrollTop = 0;
    });				
    var nativeScroll = element.find(".native_hcat");
	var contentHeight = nativeScroll.get(0).scrollHeight - nativeScroll.height();
	$(".custom_scroll_bar_handle_hcat").remove();
	if( contentHeight > 0 )
	{
	    var scrollBarHandle = jQuery(document.createElement("div"));
	    scrollBarHandle.attr({"class": "custom_scroll_bar_handle_hcat", "id": "scroll_handle_hcat"}); 		    
	    element.append(scrollBarHandle);
	    var boxHeight = element.height() - scrollBarHandle.height();
	    scrollBarHandle.css("top", "0px");
	    nativeScroll.scrollTop(0);
	    var scrollBarHandlePosition = 0;
	    var isScrollingWithMouse = false;
	    nativeScroll.unbind("scroll");
	    nativeScroll.bind("scroll", function (e) {
	        var position = nativeScroll.scrollTop() / contentHeight;
	        var scrollPosition = position * boxHeight;
	        scrollBarHandle.css("top", scrollPosition + "px");
	        if (!isScrollingWithMouse) {
	            currentScrollPosition = scrollPosition;
	        }
	    });
	    var currentScrollPosition = 0;
	    scrollBarHandle.unbind("mousedown");
	    scrollBarHandle.bind("mousedown", function (e) {
	        var startY = e.clientY;
	        var win = jQuery(document);
	        var scrollPosition;
	        isScrollingWithMouse = true;
	        var mousemove = function (e) {
	            scrollPosition = (e.clientY - startY) + currentScrollPosition;
	            var contentPosition = scrollPosition / boxHeight;
	            nativeScroll.scrollTop(contentHeight * contentPosition);
	        };
	        win.unbind("mousemove");
	        win.bind("mousemove", mousemove)
	        win.unbind("mouseup");
	        win.bind("mouseup", function () {
	            currentScrollPosition = Math.ceil((nativeScroll.scrollTop() / contentHeight) * boxHeight);
	            win.unbind("mousemove", mousemove);
	            isScrollingWithMouse = false;
	        });
	        return false;
	    });
	    scrollBarHandle.unbind("selectstart");
	    scrollBarHandle.bind("selectstart", function () {
	        return false;
	    });
	}
}());